<?php

namespace DataBase;

/**
 * @internal
 */
interface IndexInterface
{
    /**
     * @param $columnName
     *
     * @return bool
     */
    public function hasColumn($columnName);

    /**
     * @return bool
     */
    public function isUnique();

    /**
     * @param array $data
     *
     * @return bool si $data possède les colonnes de l'index
     */
    public function matchesData(array $data);

    /**
     * @param array $data
     *
     * @return array contenant uniquement les valeurs de $data avec les clés de l'index
     */
    public function getMatchingData(array $data);
}